Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.jdbc.meta
Interface FieldStrategy

All Superinterfaces:
  Serializable, Strategy

All Known Subinterfaces:
  LRSCollectionFieldStrategy, LRSMapFieldStrategy

All Known Implementing Classes:
  AbstractFieldStrategy, ContainerFieldStrategy, EmbedFieldStrategy, FieldMapping, HandlerCollectionTableFieldStrategy, HandlerFieldStrategy, HandlerHandlerMapTableFieldStrategy, HandlerRelationMapTableFieldStrategy, LobFieldStrategy, MapTableFieldStrategy, MaxEmbeddedBlobFieldStrategy, MaxEmbeddedByteArrayFieldStrategy, MaxEmbeddedCharArrayFieldStrategy, MaxEmbeddedClobFieldStrategy, MaxEmbeddedLobFieldStrategy, NoneFieldStrategy, PrimitiveFieldStrategy, RelationCollectionInverseKeyFieldStrategy, RelationCollectionTableFieldStrategy, RelationFieldStrategy, RelationHandlerMapTableFieldStrategy, RelationMapInverseKeyFieldStrategy, RelationMapTableFieldStrategy, RelationRelationMapTableFieldStrategy, RelationToManyInverseKeyFieldStrategy, RelationToManyTableFieldStrategy, StoreCollectionFieldStrategy, StringFieldStrategy

    public interface FieldStrategy

extends Strategy

Maps a persistent field to the relational schema.

Since:
  0.4.0
Author:
  Abe White

Method Summary
`void` | `appendIndex(SQLBuffer sql, Select sel, Joins joins)` Append the ordered column alias to the given statement.
`void` | `appendIsEmpty(SQLBuffer sql, Select sel, Joins joins)` Append a where clause to the given statement checking if this value is empty.
`void` | `appendIsNotEmpty(SQLBuffer sql, Select sel, Joins joins)` Append a where clause to the given statement checking if this value is not empty.
`void` | `appendIsNotNull(SQLBuffer sql, Select sel, Joins joins)` Append a where clause to the given statement checking if this value is not null.
`void` | `appendIsNull(SQLBuffer sql, Select sel, Joins joins)` Append a where clause to the given statement checking if this value is null.
`void` | `appendSize(SQLBuffer sql, Select sel, Joins joins)` Append a where clause to the given statement checking the size of the value.
`void` | `appendType(SQLBuffer sql, Select sel, Joins joins)` Append the entity discriminator value to the given statement.
`boolean` | `isEagerSelectToMany()` Whether the eager joins or selects used by this field are to-many.
`boolean` | `isVersionable()` Return true if this field can be used as part of a state image for optimistic locking.
`Joins` | `join(Joins joins, boolean forceOuter)` Join this value to the class table.
`Joins` | `joinKey(Joins joins, boolean forceOuter)` Join the key value to the class table.
`Joins` | `joinKeyRelation(Joins joins, boolean forceOuter, boolean traverse)` Join this value's table to the table for the related first class object key type, if any.
`Joins` | `joinRelation(Joins joins, boolean forceOuter, boolean traverse)` Join this value's table to the table for the related first class object type, if any.
`void` | `load(OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch)` Load secondary data using a connection from the store manager.
`void` | `load(OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch, Result res)` Load virtual row data; the given result is not guaranteed to contain data for this field, so the field mapping should make sure the result contains its needed column data before loading.
`void` | `loadEagerJoin(OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch, Result res)` Load the joined eager result.
`Object` | `loadEagerParallel(OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch, Object res)` Load the batched eager result.
`Object` | `loadKeyProjection(JDBCStore store, JDBCFetchConfiguration fetch, Result res, Joins joins)` Load this field's key value using the given result.
`Object` | `loadProjection(JDBCStore store, JDBCFetchConfiguration fetch, Result res, Joins joins)` Load this field value using the given result.
`int` | `select(Select sel, OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch, int eagerMode)` Select the virtual row columns of this mapping.
`void` | `selectEagerJoin(Select sel, OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch, int eagerMode)` Fill in joined select to related objects.
`void` | `selectEagerParallel(SelectExecutor sel, OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch, int eagerMode)` Fill in parallel eager select for related objects.
`void` | `setFieldMapping(FieldMapping owner)` Set the class mapping using this strategy.
`int` | `supportsSelect(Select sel, int type, OpenJPAStateManager sm, JDBCStore store, JDBCFetchConfiguration fetch)` Return whether this mapping can perform the given select type.
`Object` | `toDataStoreValue(Object val, JDBCStore store)` Translate the given external field value to its datastore equivalent.
`Object` | `toKeyDataStoreValue(Object val, JDBCStore store)` Translate the given key value to its datastore equivalent.
`void` | `where(OpenJPAStateManager sm, JDBCStore store, RowManager rm, Object prevValue)` Add a WHERE condition to the row for this field such that the field's current DB value must equal the given previous value.

Methods inherited from interface org.apache.openjpa.jdbc.meta.Strategy
`customDelete, customInsert, customUpdate, delete, getAlias, initialize, insert, isCustomDelete, isCustomInsert, isCustomUpdate, map, update`

Method Detail

### setFieldMapping

    void setFieldMapping(FieldMapping owner)

  Set the class mapping using this strategy. This will be called before use.

### supportsSelect

    int supportsSelect(Select sel,
                       int type,
                       OpenJPAStateManager sm,
                       JDBCStore store,
                       JDBCFetchConfiguration fetch)

  Return whether this mapping can perform the given select type. Return 0 if the given type is not supported. If the given type is an eager parallel type, return the number of UNIONed selects necessary to fetch the data. Otherwise, return any positive number if the type is supported. The given state manager may be null if selecting multiple instances.

  See Also:
    `Select`

### selectEagerParallel

    void selectEagerParallel(SelectExecutor sel,
                             OpenJPAStateManager sm,
                             JDBCStore store,
                             JDBCFetchConfiguration fetch,
                             int eagerMode)

  Fill in parallel eager select for related objects.

  See Also:
    `select(org.apache.openjpa.jdbc.sql.Select, org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore, org.apache.openjpa.jdbc.kernel.JDBCFetchConfiguration, int)`

### selectEagerJoin

    void selectEagerJoin(Select sel,
                         OpenJPAStateManager sm,
                         JDBCStore store,
                         JDBCFetchConfiguration fetch,
                         int eagerMode)

  Fill in joined select to related objects.

  See Also:
    `select(org.apache.openjpa.jdbc.sql.Select, org.apache.openjpa.kernel.OpenJPAStateManager, org.apache.openjpa.jdbc.kernel.JDBCStore, org.apache.openjpa.jdbc.kernel.JDBCFetchConfiguration, int)`

### isEagerSelectToMany

    boolean isEagerSelectToMany()

  Whether the eager joins or selects used by this field are to-many.

### select

    int select(Select sel,
               OpenJPAStateManager sm,
               JDBCStore store,
               JDBCFetchConfiguration fetch,
               int eagerMode)

  Select the virtual row columns of this mapping.

  Parameters:
    `sel` - the select to add to
    `sm` - the instance being loaded, or null if not initialized yet or selecting for multiple instances
    `store` - the current store manager
    `fetch` - fetch configuration
    `eagerMode` - the eager fetch mode to use; this may be more restrictive than the mode of the fetch configuration
  Returns:
    > 0 if this mapping requires the selected data (if any), 0 if it selected data but does not require it, or < 0 if no data was selected

### loadEagerParallel

    Object loadEagerParallel(OpenJPAStateManager sm,
                             JDBCStore store,
                             JDBCFetchConfiguration fetch,
                             Object res)
                             throws SQLException

  Load the batched eager result.

  Parameters:
    `res` - originally the `Result` to load from, but this method may return a processed result form that will be passed to subsequent calls
  Throws:
    `SQLException`

### loadEagerJoin

    void loadEagerJoin(OpenJPAStateManager sm,
                       JDBCStore store,
                       JDBCFetchConfiguration fetch,
                       Result res)
                       throws SQLException

  Load the joined eager result.

  Throws:
    `SQLException`

### load

    void load(OpenJPAStateManager sm,
              JDBCStore store,
              JDBCFetchConfiguration fetch,
              Result res)
              throws SQLException

  Load virtual row data; the given result is not guaranteed to contain data for this field, so the field mapping should make sure the result contains its needed column data before loading.

  Throws:
    `SQLException`

### load

    void load(OpenJPAStateManager sm,
              JDBCStore store,
              JDBCFetchConfiguration fetch)
              throws SQLException

  Load secondary data using a connection from the store manager.

  Throws:
    `SQLException`

### toDataStoreValue

    Object toDataStoreValue(Object val,
                            JDBCStore store)

  Translate the given external field value to its datastore equivalent. If the mapping occupies multiple columns in the datastore, return an object array, else return a single object. Simply returns the given object by default.

### toKeyDataStoreValue

    Object toKeyDataStoreValue(Object val,
                               JDBCStore store)

  Translate the given key value to its datastore equivalent. If the mapping occupies multiple columns in the datastore, return an object array, else return a single object. Simply returns the given object by default.

### appendIsEmpty

    void appendIsEmpty(SQLBuffer sql,
                       Select sel,
                       Joins joins)

  Append a where clause to the given statement checking if this value is empty. Appends impossible-to-satisfy SQL by default.

### appendIsNotEmpty

    void appendIsNotEmpty(SQLBuffer sql,
                          Select sel,
                          Joins joins)

  Append a where clause to the given statement checking if this value is not empty. Appends always-satisfied SQL by default.

### appendIsNull

    void appendIsNull(SQLBuffer sql,
                      Select sel,
                      Joins joins)

  Append a where clause to the given statement checking if this value is null.

### appendIsNotNull

    void appendIsNotNull(SQLBuffer sql,
                         Select sel,
                         Joins joins)

  Append a where clause to the given statement checking if this value is not null.

### appendSize

    void appendSize(SQLBuffer sql,
                    Select sel,
                    Joins joins)

  Append a where clause to the given statement checking the size of the value.

### appendIndex

    void appendIndex(SQLBuffer sql,
                     Select sel,
                     Joins joins)

  Append the ordered column alias to the given statement.

### appendType

    void appendType(SQLBuffer sql,
                    Select sel,
                    Joins joins)

  Append the entity discriminator value to the given statement.

### join

    Joins join(Joins joins,
               boolean forceOuter)

  Join this value to the class table. Does nothing by default.

### joinKey

    Joins joinKey(Joins joins,
                  boolean forceOuter)

  Join the key value to the class table. Does nothing by default.

### joinRelation

    Joins joinRelation(Joins joins,
                       boolean forceOuter,
                       boolean traverse)

  Join this value's table to the table for the related first class object type, if any. Does nothing by default.

  Parameters:
    `traverse` - if true, throw proper exception if it is not possible for this mapping to traverse into the related type

### joinKeyRelation

    Joins joinKeyRelation(Joins joins,
                          boolean forceOuter,
                          boolean traverse)

  Join this value's table to the table for the related first class object key type, if any. Does nothing by default.

  Parameters:
    `traverse` - if true, throw proper exception if it is not possible for this mapping to traverse into the related type

### loadProjection

    Object loadProjection(JDBCStore store,
                          JDBCFetchConfiguration fetch,
                          Result res,
                          Joins joins)
                          throws SQLException

  Load this field value using the given result. The result will contain the columns from `ValueMapping.getColumns()`.

  Throws:
    `SQLException`

### loadKeyProjection

    Object loadKeyProjection(JDBCStore store,
                             JDBCFetchConfiguration fetch,
                             Result res,
                             Joins joins)
                             throws SQLException

  Load this field's key value using the given result. The result will contain the columns from `ValueMapping.getColumns()`.

  Throws:
    `SQLException`

### isVersionable

    boolean isVersionable()

  Return true if this field can be used as part of a state image for optimistic locking.

### where

    void where(OpenJPAStateManager sm,
               JDBCStore store,
               RowManager rm,
               Object prevValue)
               throws SQLException

  Add a WHERE condition to the row for this field such that the field's current DB value must equal the given previous value. Only versionable mappings must implement this method meaningfully.

  Throws:
    `SQLException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 Apache Software Foundation. All Rights Reserved.